-- TestBench Template 

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE behavior OF testbench IS 

-- Component Declaration
	Component usb_sio
    Port ( DATA    : inout std_logic_vector(7 downto 0) bus;
           CLK     : in std_logic;
           RXF     : in std_logic;
           TXF     : in std_logic;
           RESET   : in std_logic;
           RD      : out std_logic;
           WR      : out std_logic;
           EEREQ   : out std_logic;
           --DCNT    : out std_logic_vector(3 downto 0);
           --DOUT    : out std_logic_vector(7 downto 0);
           ODIR    : out std_logic_vector(1 downto 0);
           OSTATE  : out std_logic_vector(1 downto 0);

           OCLK     : out std_logic;

           DI1     : in std_logic;
           DO1     : inout std_logic;
           CK1     : out std_logic;
           MS1     : out std_logic;
           DI2     : in std_logic;
           DO2     : inout std_logic;
           CK2     : out std_logic;
           MS2     : out std_logic

			  );

	END COMPONENT;
           signal DATA    : std_logic_vector(7 downto 0);
           signal CLK     : std_logic;
           signal RXF     : std_logic;
           signal TXF     : std_logic;
           signal RESET   : std_logic;
           signal RD      : std_logic;
           signal WR      : std_logic;
           signal EEREQ   : std_logic;
           --signal DCNT    : std_logic_vector(3 downto 0);
           --signal DOUT    : std_logic_vector(7 downto 0); 
           signal ODIR    : std_logic_vector(1 downto 0); 
           signal OSTATE  : std_logic_vector(1 downto 0); 
           signal OCLK    : std_logic;
           signal DI1     : std_logic;
           signal DO1     : std_logic;
           signal CK1     : std_logic;
           signal MS1     : std_logic;
           signal DI2     : std_logic;
           signal DO2     : std_logic;
           signal CK2     : std_logic;
           signal MS2     : std_logic;
BEGIN

-- Component Instantiation
	uut: Component usb_sio PORT MAP(
 
	   DATA => DATA,
		 CLK => CLK,
		 RXF => RXF,
		 TXF => TXF,
		 RESET => RESET,
		 RD => RD,
		 WR => WR,
		 EEREQ => EEREQ,
                 --DCNT => DCNT,
                 ---DOUT => DOUT,
		 OCLK => OCLK,
		 ODIR => ODIR,
		 OSTATE => OSTATE,
		 DI1 => DI1,
		 DI2 => DI2,
		 DO1 => DO1,
		 DO2 => DO2,
		 CK1 => CK1,
		 CK2 => CK2,
		 MS1 => MS1,
		 MS2 => MS2

	);


--  Test Bench Statements
   tb : PROCESS
   BEGIN

	   RXF <= transport '1';
		TXF <= transport '0';
		RESET <= transport '0';
	   for I in 0 to 5 loop
            CLK <= transport '1';
        WAIT FOR 80 ns;
            CLK <= transport '0';
        WAIT FOR 80 ns;
      end loop;
		RESET <= transport '1';
	   for I in 0 to 5 loop
            CLK <= transport '1';
        WAIT FOR 80 ns;
            CLK <= transport '0';
        WAIT FOR 80 ns;
      end loop;
	   RXF <= transport '0';
		DATA <= transport "00001100";
	   --DATA <= transport "00011100";
		--DATA <= transport "00000000";
		while (RD = '1') loop
		      CLK <= transport '1';
          WAIT FOR 80 ns;
            CLK <= transport '0';
          WAIT FOR 80 ns;
		end loop;

	   while (RD = '0') loop
		      CLK <= transport '1';
          WAIT FOR 80 ns;
            CLK <= transport '0';
          WAIT FOR 80 ns;
		end loop;
		DATA <= (others => 'Z');
	   RXF <= transport '1';
	   for I in 0 to 3 loop
		      CLK <= transport '1';
          WAIT FOR 80 ns;
            CLK <= transport '0';
          WAIT FOR 80 ns;
		end loop;
			   RXF <= transport '0';
		DATA <= transport "00000010";
		while (RD = '1') loop
		      CLK <= transport '1';
          WAIT FOR 80 ns;
            CLK <= transport '0';
          WAIT FOR 80 ns;
		end loop;

	   while (RD = '0') loop
		      CLK <= transport '1';
          WAIT FOR 80 ns;
            CLK <= transport '0';
          WAIT FOR 80 ns;
		end loop;
		DATA <= (others => 'Z');
	   RXF <= transport '1';
	   for I in 0 to 3 loop
		      CLK <= transport '1';
          WAIT FOR 80 ns;
            CLK <= transport '0';
          WAIT FOR 80 ns;
		end loop;
	   RXF <= transport '0';
		DATA <= transport "01010001";
		while (RD = '1') loop
		      CLK <= transport '1';
          WAIT FOR 80 ns;
            CLK <= transport '0';
          WAIT FOR 80 ns;
		end loop;

	  while (RD = '0') loop
              CLK <= transport '1';
              WAIT FOR 80 ns;
              CLK <= transport '0';
              WAIT FOR 80 ns;
          end loop;
          DATA <= (others => 'Z');
          RXF <= transport '1';
          for I in 0 to 12 loop
                 CLK <= transport '1';
                 WAIT FOR 80 ns;
                 CLK <= transport '0';
                 WAIT FOR 20 ns;
                 DI2 <= DO2;
                 DI1 <= DO1;
                 WAIT FOR 60 ns;
          end loop;

	  RXF <= transport '0';
          DATA <= transport "01010001";
          while (RD = '1') loop
                CLK <= transport '1';
                WAIT FOR 80 ns;
                CLK <= transport '0';
                WAIT FOR 80 ns;
          end loop;

	  while (RD = '0') loop
                CLK <= transport '1';
                WAIT FOR 80 ns;
                CLK <= transport '0';
                WAIT FOR 80 ns;
          end loop;
          DATA <= (others => 'Z');
          RXF <= transport '1';
          for I in 0 to 8 loop
                CLK <= transport '1';
                WAIT FOR 80 ns;
                CLK <= transport '0';
                WAIT FOR 20 ns;
                DI2 <= DO2;
                DI1 <= DO1;
                WAIT FOR 60 ns;
          end loop;


      wait; -- will wait forever
   END PROCESS;
--  End Test Bench 

END;
